/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */
 
/*
 *		f[^L[@\
 */

#include "kernel_impl.h"
#include "check.h"
#include "dataqueue.h"

/*
 *  g[XO}ÑftHg`
 */
#ifndef LOG_PSND_DTQ_ENTER
#define LOG_PSND_DTQ_ENTER(dtqid, data)
#endif /* LOG_PSND_DTQ_ENTER */

#ifndef LOG_PSND_DTQ_LEAVE
#define LOG_PSND_DTQ_LEAVE(ercd)
#endif /* LOG_PSND_DTQ_LEAVE */

#ifndef LOG_IPSND_DTQ_ENTER
#define LOG_IPSND_DTQ_ENTER(dtqid, data)
#endif /* LOG_IPSND_DTQ_ENTER */

#ifndef LOG_IPSND_DTQ_LEAVE
#define LOG_IPSND_DTQ_LEAVE(ercd)
#endif /* LOG_IPSND_DTQ_LEAVE */

#ifndef LOG_PRCV_DTQ_ENTER
#define LOG_PRCV_DTQ_ENTER(dtqid, p_data)
#endif /* LOG_PRCV_DTQ_ENTER */

#ifndef LOG_PRCV_DTQ_LEAVE
#define LOG_PRCV_DTQ_LEAVE(ercd, data)
#endif /* LOG_PRCV_DTQ_LEAVE */

/*
 *  f[^L[ւ̃f[^M
 */
void
enqueue_data(intptr_t* const data , uint8_t* const tail , const uint8_t size , const intptr_t sdata);

/*
 *  f[^L[̃f[^M
 */
void
dequeue_data(intptr_t* const data , uint8_t* const head , const uint8_t size , intptr_t* rdata);


/*
 *  f[^L[̐
 */
#define tnum_dtq	((uint_t)(tmax_dtqid - TMIN_DTQID + 1))

/*
 *  f[^L[IDf[^L[ǗubNo߂̃}N
 */
#define INDEX_DTQ(dtqid)	((uint_t)((dtqid) - TMIN_DTQID))

/*
 *  f[^L[@\̏
 */
#ifdef TOPPERS_dtqini

void
initialize_dataqueue(void)
{
	uint_t	i;

	for (i = 0U ; i < tnum_dtq ; i++) {
		dtqcb_count[i] = 0U;
		dtqcb_head[i] = 0U;
		dtqcb_tail[i] = 0U;
	}
}

#endif /* TOPPERS_dtqini */


/*
 *  f[^L[t̃`FbN
 */

Inline bool_t
data_full(uint8_t count , uint8_t size)
{
	return (count >= size)? true : false;
}

/*
 *  f[^L[󂩂̃`FbN
 */

Inline bool_t
data_empty(uint8_t count)
{
	return (count == 0)? true : false;
}


/*
 *  f[^L[ւ̃f[^M
 */


#ifdef TOPPERS_dtqenq

void
enqueue_data(intptr_t* const data , uint8_t* const tail , const uint8_t size , const intptr_t sdata)
{
	data[*tail] = sdata;
	(*tail)++;
	if (*tail >= size) {
		*tail = 0U;
	}
}

#endif /* TOPPERS_dtqenq */

/*
 *  M҂L[̐擪^XÑf[^M
 */
#ifdef TOPPERS_dtqdeq

void
dequeue_data(intptr_t* const data , uint8_t* const head , const uint8_t size , intptr_t* rdata)
{
	*rdata = data[*head];
	(*head)++;
	if (*head >= size) {
		*head = 0U;
	}
	
}

#endif /* TOPPERS_dtqdeq */

/*
 *  f[^L[ւ̑Mi|[Oj
 */
#ifdef TOPPERS_psnd_dtq

ER
psnd_dtq(ID dtqid, intptr_t data)
{
	ER		ercd;
	int_t	index;
	
	LOG_PSND_DTQ_ENTER(dtqid, data);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	
	t_lock_cpu();
	index = INDEX_DTQ(dtqid);
	
	if (!data_full(dtqcb_count[index] , dtqinib_size[index]))
	{
		enqueue_data(dtqinib_data[index] , &(dtqcb_tail[index]) , 
					dtqinib_size[index] , data);
		dtqcb_count[index]++;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();
	
  error_exit:
	LOG_PSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_psnd_dtq */

/*
 *  f[^L[ւ̑Mi|[OC^XNReLXgpj
 */
#ifdef TOPPERS_ipsnd_dtq

ER
ipsnd_dtq(ID dtqid, intptr_t data)
{
	ER		ercd;
	int_t	index;

	LOG_IPSND_DTQ_ENTER(dtqid, data);
	CHECK_INTCTX_UNL();
	CHECK_DTQID(dtqid);

	i_lock_cpu();
	index = INDEX_DTQ(dtqid);
	
	if (!data_full(dtqcb_count[index] , dtqinib_size[index]))
	{
		enqueue_data(dtqinib_data[index] , &(dtqcb_tail[index]) , 
					dtqinib_size[index] , data);
		dtqcb_count[index]++;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	i_unlock_cpu();

  error_exit:
	LOG_IPSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ipsnd_dtq */

/*
 *  f[^L[̎Mi|[Oj
 */
#ifdef TOPPERS_prcv_dtq

ER
prcv_dtq(ID dtqid, intptr_t *p_data)
{
	ER		ercd;
	int_t	index;

	LOG_PRCV_DTQ_ENTER(dtqid, p_data);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);

	t_lock_cpu();
	index = INDEX_DTQ(dtqid);
	
	if (!data_empty(dtqcb_count[index]))
	{
		dequeue_data(dtqinib_data[index] , &(dtqcb_head[index]) , 
					dtqinib_size[index] , p_data);
		dtqcb_count[index]--;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PRCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* TOPPERS_prcv_dtq */
